=== debian/changelog ===
pytorch (2.4.1-1ubuntu1) oracular; urgency=medium

  * Merge with Debian; remaining changes:
    - Add explicit (build)dependency on python3-packaging.
  * Build using LLVM 18.
  * Build using sleef 3.7.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 03 Oct 2024 12:14:23 +0200

pytorch (2.4.1-1) unstable; urgency=medium

  [ Shengqi Chen ]
  * d/README.Source: update dependency status

  [ Mo Zhou ]
  * New upstream version 2.4.1 (Closes: #1070379, #1078808, #1078795)
    (Fixes CVE-2024-31580 CVE-2024-31583 CVE-2024-31584)
    + Bump SOVERSION from 2.1 to 2.4
    * Require versioned B-D sleef >= 3.6.1-1~. (Closes: #1071655)
      Sleef was the reason why the 2.1.2 version FTBFS on ppc64el.
    * Conflicts+Replaces libtorch2.1 and libtorch-cuda-2.1.
    * Update d/rules and install libnnapi_backend.so for CPU version.
    * Re-generate the autopkgtest control file.
    * README.Source: update dependency list. All clear for 2.4.1 CPU version.
    * d/copyright: update for the new release.
  * Embeded and Third-Party Sources:
    - d/copyright: Exclude newly embeded opentelemetry-cpp and cpp-httplib
    - d/copyright: embeded third_party/nvfuser has been removed by upstream.
    - Remove embeded expecttest since it has been individually packaged.
    - Remove redundant copy of embeded valgrind headers.
    * Upgrade embeded kineto be1317644c68b4bfc4646024a6b221066e430031.
    * Upgrade embeded pocketfft to 9d3ab05a7fffbc71a492bc6a17be034e83e8f0fe.
    * Apply patch to embeded kineto.
    * Embed a partial copy of dynolog-7d04a0053a845370ae06ce317a22a48e9edcc74e
      into the embeded kineto.
  * Patchwork:
    * Rebase and refresh all existing patches.
    + Add patch to remove the dependency on opentelemetry.
    + Patch code to use system cpp-httplib instead.
    + Patch cmake to fix sleef symbol missing linker error for test binaries.
    * Hack CMake to workaround install path issue for caffe2.
  * Remove deprecated pytorch-src install script.

 -- Mo Zhou <lumin@debian.org>  Sun, 29 Sep 2024 21:37:55 -0400

pytorch (2.1.2+dfsg-4ubuntu3) oracular; urgency=medium

  * Rebuild against new libavcodec61.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 17:33:33 +0200

pytorch (2.1.2+dfsg-4ubuntu2) oracular; urgency=medium

  * Add explicit (build)dependency on python3-packaging.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 Jul 2024 13:12:45 +0200
